require 'json'
require 'gallus'
require 'active_support/core_ext/hash'
require 'active_support/core_ext/module'
require 'active_support/core_ext/string/inflections'

module Stargate
  include Gallus::PackageLogging

  # Logging proxy, just in case someday you'd like to switch to different logging lib.
  Logging = Gallus::Logging

  # Public: Base error.
  Error = Class.new(StandardError)

  # In-process registry.
  INPROC = {}

  # Configure logging defaults.
  ENV['STARGATE_LOG_LEVEL'] = 'DEBUG' if ENV['DEBUG'].to_i > 0
  log.level = ENV.fetch('STARGATE_LOG_LEVEL', 'INFO')

  require 'stargate/version'
  require 'stargate/serialization'
  require 'stargate/codec'
  require 'stargate/marshal'
  require 'stargate/metadata'
end
