module Kernel
  # Public: Loads remote definitions from given URL and injects them in local namespace.
  #
  # Example:
  #
  #   require_remote('http+json://example.com/v1#timeout=0.3')
  #
  # Returns nothing.
  def require_remote(url)
    @required_remotes ||= []
    return if @required_remotes.include?(url)
    injector = Stargate::Client::Injector.new(url)
    @required_remotes << url
    nil
  end
end
