module Stargate
  module Client
    # Public: Raised when data has been fetched but execution failed.
    class RemoteExecutionError < Error
      def self.from_hash(hash)
        hash.symbolize_keys!
        new(hash[:error], hash[:message])
      end

      attr_reader :cause_type

      def initialize(cause_type, message)
        @cause_type = cause_type
        super(message)
      end

      def inspect
        "#{self.class.name} caused by #{cause_type}: #{message}"
      end
    end
  end
end
