require 'bencode'

module Stargate
  module Codec
    # Internal: BEncode (BitTorrent encoding) powered codec.
    class BEncode
      def self.id
        :bencode
      end

      def self.content_type
        'application/bencode'
      end

      def self.encode(obj)
        obj.bencode
      end

      def self.decode(str)
        ::BEncode::Parser.new(str).parse!
      rescue ::BEncode::DecodeError => err
        raise DecodeError, "Arguments cannot be decoded: bencode parser error"
      end
    end

    register BEncode
  end
end
