require 'json'

module Stargate
  module Codec
    # Internal: Default codec based on JSON parser.
    class JSON
      def self.id
        :json
      end

      def self.content_type
        'application/json'
      end

      def self.encode(obj)
        obj.to_json
      end

      def self.decode(str)
        ::JSON.parse(str)
      rescue ::JSON::ParserError => err
        raise DecodeError, "Arguments cannot be decoded: JSON parser error"
      end
    end

    register JSON
  end
end
