require 'msgpack'

module Stargate
  module Codec
    # Internal: Serialization done with MessagePack format.
    class MessagePack
      def self.id
        :msgpack
      end

      def self.content_type
        'application/msgpack'
      end

      def self.encode(obj)
        ::MessagePack.pack(obj)
      end

      def self.decode(str)
        ::MessagePack.unpack(str)
      rescue ::MessagePack::MalformedFormatError => err
        raise DecodeError, "Arguments cannot be decoded: MessagePack parser error"
      end
    end

    register MessagePack
  end
end
