module Stargate
  # Internal: This tiny mixin provides serialization directives for includee class. The target class must
  # implement #serialize method.
  module Serialization
    def serialize
      raise NotImplementedError, "Not implemented: #{self.class.name}#serialize"
    end

    def to_json(*args)
      serialize.to_json(*args)
    end

    def to_msgpack(*args)
      serialize.to_msgpack(*args)
    end

    def bencode
      serialize.bencode
    end
  end
end
