require 'stargate/serialization'

module Stargate
  module Marshal
    # Internal: We need some packaging to move stuff from one machine to another. We have to know what types
    # are coming in. We distinguish four base types:
    #
    # * Simple type (string, number, booleans),
    # * Symbol,
    # * List (Array),
    # * Hash
    #
    # Later, we can pack any other type that has been registered for exchange.
    class Payload < Struct.new(:type, :data)
      include Serialization

      LIST   = :a
      SIMPLE = :b
      SYMBOL = :s
      HASH   = :h

      def serialize
        [ type, data ]
      end

      def inspect
        serialize.inspect
      end
    end
  end
end
